/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "gototoolbar.h"

GotoLineToolbar::GotoLineToolbar()
{
  // Create Horizontal Goto Line 'Toolbar'
  button_close = new Gtk::Button();
  label_goto_line = new Gtk::Label("Goto Line: ");
  button_goto_line = new Gtk::Button(Gtk::StockID("gtk-jump-to"));
  image_error = new Gtk::Image(Gtk::StockID("gtk-dialog-error"), Gtk::IconSize(1));
  image_close = new Gtk::Image(Gtk::StockID("gtk-stop"), Gtk::IconSize(1));
  label_error = new Gtk::Label("Line out of bounds!");
  Gtk::Adjustment *spinbutton_adj = new Gtk::Adjustment(1, 1, 99999, 1, 10, 10);
  goto_line = new Gtk::SpinButton(*spinbutton_adj, 1, 0);

  // Create the buttons
  button_close->set_relief(Gtk::RELIEF_NONE);
	button_close->add(*image_close);
  button_goto_line->set_relief(Gtk::RELIEF_NONE);
  
  // Add the widgets to the horizontal box
  set_spacing(5);
  set_border_width(3);
  pack_start(*button_close, Gtk::PACK_SHRINK);
  pack_start(*label_goto_line, Gtk::PACK_SHRINK);
  pack_start(*goto_line, Gtk::PACK_SHRINK);
  pack_start(*button_goto_line, Gtk::PACK_SHRINK, 5);
  pack_start(*image_error, Gtk::PACK_SHRINK);
  pack_start(*label_error, Gtk::PACK_SHRINK);
}
  
void GotoLineToolbar::show_error (bool show)
{
  if (show)
  {
    label_error->show();
    image_error->show();
  }
  else
  {
    label_error->hide();
    image_error->hide();
  }
}

Gtk::Button* GotoLineToolbar::get_close()
{ return button_close;
}

Gtk::Button* GotoLineToolbar::get_goto()
{ return button_goto_line;
}

int GotoLineToolbar::get_goto_value()
{ return goto_line->get_value_as_int();
}
