/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef NEW_H
#define NEW_H

#include "template.h"

#include <cstdio>
#include <gtkmm/button.h>
#include <gtkmm/combo.h>
#include <gtkmm/entry.h>
#include <gtkmm/filechooserdialog.h>
#include <gtkmm/fixed.h>
#include <gtkmm/label.h>
#include <gtkmm/liststore.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/separator.h>
#include <gtkmm/stock.h>
#include <gtkmm/table.h>
#include <gtkmm/treemodel.h>
#include <libglademm/xml.h>
#include <sys/stat.h>

// New file/project class
class NewProjectDialog
{
public:
  NewProjectDialog (TemplateList*);
  ~NewProjectDialog();

  Gtk::Dialog* get_dialog();
  void initialize_objects();
  void populate_combobox();
  void on_apply();
  void on_cancel();
  void on_browse();

  bool key_pressed_name(GdkEventKey*);
  Glib::ustring get_filename();

  Glib::ustring check_for_errors();
  Glib::ustring create_odp_file_text(Glib::ustring&);
  void create_location();
  void create_project_from_template(Glib::ustring);
  void clean_white_space_and_replace_content (Glib::ustring&, bool);

private:
  Gtk::Dialog *dialog;
  Gtk::Button *cancel, *apply, *browse;
  Gtk::Entry *name, *author, *email, *homepage, *version, *location;
  Gtk::Combo *combobox;
  Glib::ustring file_location;
  TemplateList *tlist;
};

#endif
